Index: kernel/arch/amd64/include/arch/mm/pat.h
===================================================================
--- kernel/arch/amd64/include/arch/mm/pat.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ kernel/arch/amd64/include/arch/mm/pat.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,85 @@
+/*
+ * Copyright (c) 2024 Jiri Svoboda
+ * Copyright (c) 2024 Jiří Zárevúcky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup kernel_amd64_mm
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_amd64_MM_PAT_H_
+#define KERN_amd64_MM_PAT_H_
+
+#include <arch/asm.h>
+#include <arch/cpuid.h>
+
+#define MSR_IA32_PAT  0x00000277
+
+typedef enum {
+	PAT_TYPE_UNCACHEABLE = 0,
+	PAT_TYPE_WRITE_COMBINING = 1,
+	PAT_TYPE_WRITE_THROUGH = 4,
+	PAT_TYPE_WRITE_PROTECTED = 5,
+	PAT_TYPE_WRITE_BACK = 6,
+	PAT_TYPE_UNCACHED  = 7,
+} pat_type_t;
+
+#ifndef PROCESSOR_i486
+/**
+ * Assign caching type for a particular combination of PAT,
+ * PCD and PWT bits in PTE.
+ */
+static inline void pat_set_mapping(bool pat, bool pcd, bool pwt,
+    pat_type_t type)
+{
+	int index = pat << 2 | pcd << 1 | pwt;
+	int shift = index * 8;
+
+	uint64_t r = read_msr(MSR_IA32_PAT);
+	r &= ~(0xffull << shift);
+	r |= ((uint64_t) type) << shift;
+	write_msr(MSR_IA32_PAT, r);
+}
+#endif
+
+static inline bool pat_supported(void)
+{
+	if (!has_cpuid())
+		return false;
+
+	cpu_info_t info;
+	cpuid(INTEL_CPUID_STANDARD, &info);
+
+	return (info.cpuid_edx & (1 << 16)) != 0;
+}
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/amd64/src/amd64.c
===================================================================
--- kernel/arch/amd64/src/amd64.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/amd64/src/amd64.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -37,5 +37,5 @@
 #include <stdint.h>
 #include <errno.h>
-#include <mem.h>
+#include <memw.h>
 #include <interrupt.h>
 #include <console/console.h>
@@ -60,4 +60,5 @@
 #include <arch/vreg.h>
 #include <arch/kseg.h>
+#include <arch/mm/pat.h>
 #include <genarch/pic/pic_ops.h>
 
@@ -115,4 +116,8 @@
 	/* Disable alignment check */
 	write_cr0(read_cr0() & ~CR0_AM);
+
+	/* Use PCD+PWT bit combination in PTE to mean write-combining mode. */
+	if (pat_supported())
+		pat_set_mapping(false, true, true, PAT_TYPE_WRITE_COMBINING);
 
 	if (config.cpu_active == 1) {
Index: kernel/arch/amd64/src/cpu/cpu.c
===================================================================
--- kernel/arch/amd64/src/cpu/cpu.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/amd64/src/cpu/cpu.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -99,5 +99,4 @@
 	CPU->arch.tss->iomap_base = &CPU->arch.tss->iomap[0] -
 	    ((uint8_t *) CPU->arch.tss);
-	CPU->fpu_owner = NULL;
 }
 
Index: kernel/arch/amd64/src/pm.c
===================================================================
--- kernel/arch/amd64/src/pm.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/amd64/src/pm.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -39,5 +39,5 @@
 #include <mm/as.h>
 #include <mm/frame.h>
-#include <mem.h>
+#include <memw.h>
 #include <stdlib.h>
 
Index: kernel/arch/amd64/src/smp/ap.S
===================================================================
--- kernel/arch/amd64/src/smp/ap.S	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/amd64/src/smp/ap.S	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -98,7 +98,8 @@
 .code64
 start64:
-	movabsq $ctx, %rsp
-	movq CONTEXT_OFFSET_SP(%rsp), %rsp
+	movabsq $bootstrap_stack_top, %rsp
+	movq (%rsp), %rsp
 
+	pushq $0
 	pushq $0
 	movq %rsp, %rbp
Index: kernel/arch/arm32/_link.ld.in
===================================================================
--- kernel/arch/arm32/_link.ld.in	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm32/_link.ld.in	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -26,28 +26,67 @@
 	kernel_load_address = .;
 	. = . + SIZEOF_HEADERS;
+
 	.text : {
 		ktext_start = .;
-		*(.text);
+		*(.text .text.*);
 		ktext_end = .;
 	}
+
+	/* stack unwinding data */
+	.eh_frame_hdr : {
+		eh_frame_hdr_start = .;
+		*(.eh_frame_hdr) *(.eh_frame_entry .eh_frame_entry.*);
+		eh_frame_hdr_end = .;
+	}
+
+	.eh_frame : {
+		eh_frame_start = .;
+		KEEP(*(.eh_frame .eh_frame.*));
+		eh_frame_end = .;
+	}
+
 	.data : {
 		kdata_start = .;
-		*(.data);                       /* initialized data */
-		*(.bss);                        /* uninitialized static variables */
+		*(.data .data.*);                       /* initialized data */
+		*(.bss .bss.*);                        /* uninitialized static variables */
 		*(COMMON);                      /* global variables */
 
-		*(.rodata*);
-		*(.sdata);
-		*(.reginfo);
-		. = ALIGN(8);
-		symbol_table = .;
-		*(symtab.*);
-	}
-	.sbss : {
-		*(.sbss);
-		*(.scommon);
+		*(.rodata .rodata.*);
+		*(.sdata .sdata.*);
+		*(.sbss .sbss.*);
+		*(.scommon .scommon.*);
+		kdata_end = .;
 	}
 
-	kdata_end = .;
+	.comment 0 : { *(.comment); }
+	.debug_abbrev 0 : { *(.debug_abbrev); }
+	.debug_abbrev.dwo 0 : { *(	.debug_abbrev.dwo); }
+	.debug_addr 0 : { *(.debug_addr); }
+	.debug_aranges 0 : { *(.debug_aranges); }
+	.debug_cu_index 0 : { *(.debug_cu_index); }
+	.debug_frame 0 : { *(.debug_frame); }
+	.debug_frame_hdr 0 : { *(.debug_frame_hdr); }
+	.debug_info 0 : { *(.debug_info); }
+	.debug_info.dwo 0 : { *(.debug_info.dwo); }
+	.debug_line 0 : { *(.debug_line); }
+	.debug_line.dwo 0 : { *(.debug_line.dwo); }
+	.debug_line_str 0 : { *(.debug_line_str); }
+	.debug_loc 0 : { *(.debug_loc); }
+	.debug_loclists 0 : { *(.debug_loclists); }
+	.debug_loclists.dwo 0 : { *(.debug_loclists.dwo); }
+	.debug_macinfo 0 : { *(.debug_macinfo); }
+	.debug_macro 0 : { *(.debug_macro); }
+	.debug_macro.dwo 0 : { *(.debug_macro.dwo); }
+	.debug_names 0 : { *(.debug_names); }
+	.debug_pubnames 0 : { *(.debug_pubnames); }
+	.debug_pubtypes 0 : { *(.debug_pubtypes); }
+	.debug_ranges 0 : { *(.debug_ranges); }
+	.debug_rnglists 0 : { *(.debug_rnglists); }
+	.debug_str 0 : { *(.debug_str); }
+	.debug_str.dwo 0 : { *(.debug_str.dwo); }
+	.debug_str_offsets 0 : { *(.debug_str_offsets); }
+	.debug_str_offsets.dwo 0 : { *(.debug_str_offsets.dwo); }
+	.debug_tu_index 0 : { *(.debug_tu_index); }
+	.debug_types 0 : { *(.debug_types); }
 
 	/DISCARD/ : {
Index: kernel/arch/arm32/include/arch/asm.h
===================================================================
--- kernel/arch/arm32/include/arch/asm.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm32/include/arch/asm.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -65,4 +65,23 @@
 }
 
+/** Enables interrupts and blocks until an interrupt arrives,
+ * atomically if possible on target architecture.
+ * Disables interrupts again before returning to caller.
+ */
+_NO_TRACE static inline void cpu_interruptible_sleep(void)
+{
+	// FIXME: do this atomically
+	interrupts_enable();
+	cpu_sleep();
+	interrupts_disable();
+}
+
+_NO_TRACE static inline void cpu_spin_hint(void)
+{
+#ifdef PROCESSOR_ARCH_armv7_a
+	asm volatile ("yield");
+#endif
+}
+
 _NO_TRACE static inline void pio_write_8(ioport8_t *port, uint8_t v)
 {
Index: kernel/arch/arm32/include/arch/fpu_context.h
===================================================================
--- kernel/arch/arm32/include/arch/fpu_context.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm32/include/arch/fpu_context.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -40,11 +40,9 @@
 #include <stdint.h>
 
-#define FPU_CONTEXT_ALIGN    8
-
 /*
  * ARM Architecture reference manual, p B-1529.
  */
 typedef struct {
-	uint32_t fpexc;
+	_Alignas(8) uint32_t fpexc;
 	uint32_t fpscr;
 	uint32_t s[64];
Index: kernel/arch/arm32/src/atomic.c
===================================================================
--- kernel/arch/arm32/src/atomic.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm32/src/atomic.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -38,6 +38,8 @@
 #include <arch/asm.h>
 
-unsigned __atomic_fetch_add_4(volatile unsigned *mem, unsigned val, int model)
+unsigned __atomic_fetch_add_4(volatile void *mem0, unsigned val, int model)
 {
+	volatile unsigned *mem = mem0;
+
 	/*
 	 * This implementation is for UP pre-ARMv6 systems where we do not have
@@ -51,6 +53,8 @@
 }
 
-unsigned __atomic_fetch_sub_4(volatile unsigned *mem, unsigned val, int model)
+unsigned __atomic_fetch_sub_4(volatile void *mem0, unsigned val, int model)
 {
+	volatile unsigned *mem = mem0;
+
 	ipl_t ipl = interrupts_disable();
 	unsigned ret = *mem;
@@ -67,6 +71,9 @@
  * returns the previous value of \a *ptr.
  */
-void *__sync_val_compare_and_swap_4(void **ptr, void *expected, void *new_val)
+unsigned __sync_val_compare_and_swap_4(volatile void *ptr0, unsigned expected,
+    unsigned new_val)
 {
+	volatile unsigned *ptr = ptr0;
+
 	/*
 	 * Using an interrupt disabling spinlock might still lead to deadlock
@@ -78,5 +85,5 @@
 	irq_spinlock_lock(&cas_lock, true);
 
-	void *cur_val = *ptr;
+	unsigned cur_val = *ptr;
 
 	if (cur_val == expected) {
@@ -96,12 +103,15 @@
 /* Naive implementations of the newer intrinsics. */
 
-_Bool __atomic_compare_exchange_4(void **mem, void **expected, void *desired, _Bool weak, int success, int failure)
+_Bool __atomic_compare_exchange_4(volatile void *mem, void *expected0,
+    unsigned desired, _Bool weak, int success, int failure)
 {
+	unsigned *expected = expected0;
+
 	(void) weak;
 	(void) success;
 	(void) failure;
 
-	void *old = *expected;
-	void *new = __sync_val_compare_and_swap_4(mem, old, desired);
+	unsigned old = *expected;
+	unsigned new = __sync_val_compare_and_swap_4(mem, old, desired);
 	if (old == new) {
 		return 1;
@@ -112,10 +122,12 @@
 }
 
-void *__atomic_exchange_4(void **mem, void *val, int model)
+unsigned __atomic_exchange_4(volatile void *mem0, unsigned val, int model)
 {
+	volatile unsigned *mem = mem0;
+
 	(void) model;
 
 	irq_spinlock_lock(&cas_lock, true);
-	void *old = *mem;
+	unsigned old = *mem;
 	*mem = val;
 	irq_spinlock_unlock(&cas_lock, true);
Index: kernel/arch/arm32/src/mach/beagleboardxm/beagleboardxm.c
===================================================================
--- kernel/arch/arm32/src/mach/beagleboardxm/beagleboardxm.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm32/src/mach/beagleboardxm/beagleboardxm.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -92,7 +92,7 @@
 	 * Release the lock, call clock() and reacquire the lock again.
 	 */
-	spinlock_unlock(&irq->lock);
+	irq_spinlock_unlock(&irq->lock, false);
 	clock();
-	spinlock_lock(&irq->lock);
+	irq_spinlock_lock(&irq->lock, false);
 }
 
@@ -156,5 +156,5 @@
 		/* The IRQ handler was found. */
 		irq->handler(irq);
-		spinlock_unlock(&irq->lock);
+		irq_spinlock_unlock(&irq->lock, false);
 	} else {
 		/* Spurious interrupt. */
Index: kernel/arch/arm32/src/mach/beaglebone/beaglebone.c
===================================================================
--- kernel/arch/arm32/src/mach/beaglebone/beaglebone.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm32/src/mach/beaglebone/beaglebone.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -117,7 +117,7 @@
 {
 	am335x_timer_intr_ack(&bbone.timer);
-	spinlock_unlock(&irq->lock);
+	irq_spinlock_unlock(&irq->lock, false);
 	clock();
-	spinlock_lock(&irq->lock);
+	irq_spinlock_lock(&irq->lock, false);
 }
 
@@ -184,5 +184,5 @@
 		/* The IRQ handler was found. */
 		irq->handler(irq);
-		spinlock_unlock(&irq->lock);
+		irq_spinlock_unlock(&irq->lock, false);
 	} else {
 		printf("Spurious interrupt\n");
Index: kernel/arch/arm32/src/mach/gta02/gta02.c
===================================================================
--- kernel/arch/arm32/src/mach/gta02/gta02.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm32/src/mach/gta02/gta02.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -146,5 +146,5 @@
 		/* The IRQ handler was found. */
 		irq->handler(irq);
-		spinlock_unlock(&irq->lock);
+		irq_spinlock_unlock(&irq->lock, false);
 	} else {
 		/* Spurious interrupt. */
@@ -258,7 +258,7 @@
 	 * Release the lock, call clock() and reacquire the lock again.
 	 */
-	spinlock_unlock(&irq->lock);
+	irq_spinlock_unlock(&irq->lock, false);
 	clock();
-	spinlock_lock(&irq->lock);
+	irq_spinlock_lock(&irq->lock, false);
 }
 
Index: kernel/arch/arm32/src/mach/integratorcp/integratorcp.c
===================================================================
--- kernel/arch/arm32/src/mach/integratorcp/integratorcp.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm32/src/mach/integratorcp/integratorcp.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -197,7 +197,7 @@
 	 */
 
-	spinlock_unlock(&irq->lock);
+	irq_spinlock_unlock(&irq->lock, false);
 	clock();
-	spinlock_lock(&irq->lock);
+	irq_spinlock_lock(&irq->lock, false);
 
 }
@@ -268,5 +268,5 @@
 				/* The IRQ handler was found. */
 				irq->handler(irq);
-				spinlock_unlock(&irq->lock);
+				irq_spinlock_unlock(&irq->lock, false);
 			} else {
 				/* Spurious interrupt. */
Index: kernel/arch/arm32/src/mach/raspberrypi/raspberrypi.c
===================================================================
--- kernel/arch/arm32/src/mach/raspberrypi/raspberrypi.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm32/src/mach/raspberrypi/raspberrypi.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -94,7 +94,7 @@
 {
 	bcm2835_timer_irq_ack(raspi.timer);
-	spinlock_unlock(&irq->lock);
+	irq_spinlock_unlock(&irq->lock, false);
 	clock();
-	spinlock_lock(&irq->lock);
+	irq_spinlock_lock(&irq->lock, false);
 }
 
@@ -159,5 +159,5 @@
 		/* The IRQ handler was found. */
 		irq->handler(irq);
-		spinlock_unlock(&irq->lock);
+		irq_spinlock_unlock(&irq->lock, false);
 	} else {
 		/* Spurious interrupt. */
Index: kernel/arch/arm32/src/ras.c
===================================================================
--- kernel/arch/arm32/src/ras.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm32/src/ras.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -44,5 +44,5 @@
 #include <arch/exception.h>
 #include <arch.h>
-#include <mem.h>
+#include <memw.h>
 #include <typedefs.h>
 
Index: kernel/arch/arm64/_link.ld.in
===================================================================
--- kernel/arch/arm64/_link.ld.in	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm64/_link.ld.in	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -19,39 +19,65 @@
 	kernel_load_address = LOAD_ADDRESS_V;
 
-	.image (LOAD_ADDRESS_V + SIZEOF_HEADERS) : AT (LOAD_ADDRESS_P + SIZEOF_HEADERS) {
+	.text (LOAD_ADDRESS_V + SIZEOF_HEADERS) : AT (LOAD_ADDRESS_P + SIZEOF_HEADERS) {
 		. = ALIGN(16);
 		ktext_start = .;
-		*(K_TEXT_START)
+		KEEP(*(K_TEXT_START))
 		*(.text .text.*);
 		ktext_end = .;
+	}
 
+	/* stack unwinding data */
+	.eh_frame_hdr : {
+		eh_frame_hdr_start = .;
+		*(.eh_frame_hdr) *(.eh_frame_entry .eh_frame_entry.*);
+		eh_frame_hdr_end = .;
+	}
+
+	.eh_frame : {
+		eh_frame_start = .;
+		KEEP(*(.eh_frame .eh_frame.*));
+		eh_frame_end = .;
+	}
+
+	.data : {
 		kdata_start = .;
-		*(K_DATA_START)
-		*(.data);                       /* initialized data */
-		*(.bss);                        /* uninitialized static variables */
+		KEEP(*(K_DATA_START))
+		*(.rodata .rodata.*);
+		*(.data .data.*);                       /* initialized data */
+		*(.bss .bss.*);                        /* uninitialized static variables */
 		*(COMMON);                      /* global variables */
-
-		*(.rodata*);
-		. = ALIGN(8);
-		symbol_table = .;
-		*(symtab.*);
-
 		kdata_end = .;
 	}
 
-#ifdef CONFIG_LINE_DEBUG
 	.comment 0 : { *(.comment); }
 	.debug_abbrev 0 : { *(.debug_abbrev); }
+	.debug_abbrev.dwo 0 : { *(	.debug_abbrev.dwo); }
+	.debug_addr 0 : { *(.debug_addr); }
 	.debug_aranges 0 : { *(.debug_aranges); }
+	.debug_cu_index 0 : { *(.debug_cu_index); }
 	.debug_frame 0 : { *(.debug_frame); }
+	.debug_frame_hdr 0 : { *(.debug_frame_hdr); }
 	.debug_info 0 : { *(.debug_info); }
+	.debug_info.dwo 0 : { *(.debug_info.dwo); }
 	.debug_line 0 : { *(.debug_line); }
+	.debug_line.dwo 0 : { *(.debug_line.dwo); }
+	.debug_line_str 0 : { *(.debug_line_str); }
 	.debug_loc 0 : { *(.debug_loc); }
+	.debug_loclists 0 : { *(.debug_loclists); }
+	.debug_loclists.dwo 0 : { *(.debug_loclists.dwo); }
 	.debug_macinfo 0 : { *(.debug_macinfo); }
+	.debug_macro 0 : { *(.debug_macro); }
+	.debug_macro.dwo 0 : { *(.debug_macro.dwo); }
+	.debug_names 0 : { *(.debug_names); }
 	.debug_pubnames 0 : { *(.debug_pubnames); }
 	.debug_pubtypes 0 : { *(.debug_pubtypes); }
 	.debug_ranges 0 : { *(.debug_ranges); }
+	.debug_rnglists 0 : { *(.debug_rnglists); }
 	.debug_str 0 : { *(.debug_str); }
-#endif
+	.debug_str.dwo 0 : { *(.debug_str.dwo); }
+	.debug_str_offsets 0 : { *(.debug_str_offsets); }
+	.debug_str_offsets.dwo 0 : { *(.debug_str_offsets.dwo); }
+	.debug_tu_index 0 : { *(.debug_tu_index); }
+	.debug_types 0 : { *(.debug_types); }
 
 	/DISCARD/ : {
Index: kernel/arch/arm64/include/arch/asm.h
===================================================================
--- kernel/arch/arm64/include/arch/asm.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm64/include/arch/asm.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -54,4 +54,16 @@
 }
 
+/** Enables interrupts and blocks until an interrupt arrives,
+ * atomically if possible on target architecture.
+ * Disables interrupts again before returning to caller.
+ */
+_NO_TRACE static inline void cpu_interruptible_sleep(void)
+{
+	// FIXME: do this atomically
+	interrupts_enable();
+	cpu_sleep();
+	interrupts_disable();
+}
+
 /** Halts CPU. */
 _NO_TRACE static inline __attribute__((noreturn)) void cpu_halt(void)
@@ -59,4 +71,9 @@
 	while (true)
 		;
+}
+
+_NO_TRACE static inline void cpu_spin_hint(void)
+{
+	asm volatile ("yield");
 }
 
Index: kernel/arch/arm64/include/arch/context_struct.h
===================================================================
--- kernel/arch/arm64/include/arch/context_struct.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm64/include/arch/context_struct.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -43,6 +43,5 @@
 #define CONTEXT_OFFSET_X28  0x58
 #define CONTEXT_OFFSET_X29  0x60
-#define CONTEXT_OFFSET_IPL  0x68
-#define CONTEXT_SIZE        0x70
+#define CONTEXT_SIZE        0x68
 
 #ifndef __ASSEMBLER__
@@ -68,5 +67,4 @@
 	uint64_t x28;
 	uint64_t x29;
-	ipl_t ipl;
 } context_t;
 
Index: kernel/arch/arm64/include/arch/fpu_context.h
===================================================================
--- kernel/arch/arm64/include/arch/fpu_context.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm64/include/arch/fpu_context.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -39,6 +39,4 @@
 #include <arch/fpu_context_struct.h>
 
-#define FPU_CONTEXT_ALIGN  16
-
 #endif
 
Index: kernel/arch/arm64/include/arch/fpu_context_struct.h
===================================================================
--- kernel/arch/arm64/include/arch/fpu_context_struct.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm64/include/arch/fpu_context_struct.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -42,5 +42,5 @@
 /** ARM64 FPU context. */
 typedef struct fpu_context {
-	uint128_t vregs[32];
+	_Alignas(16) uint128_t vregs[32];
 	uint32_t fpcr;
 	uint32_t fpsr;
Index: kernel/arch/arm64/src/interrupt.c
===================================================================
--- kernel/arch/arm64/src/interrupt.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm64/src/interrupt.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -137,5 +137,5 @@
 	while (drift > timer_increment) {
 		drift -= timer_increment;
-		CPU->missed_clock_ticks++;
+		CPU_LOCAL->missed_clock_ticks++;
 	}
 	CNTV_CVAL_EL0_write(cntvct + timer_increment - drift);
Index: kernel/arch/ia32/_link.ld.in
===================================================================
--- kernel/arch/ia32/_link.ld.in	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia32/_link.ld.in	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -17,40 +17,74 @@
 	.unmapped (BOOT_OFFSET + SIZEOF_HEADERS): AT (BOOT_OFFSET + SIZEOF_HEADERS) {
 		unmapped_start = .;
-		*(K_TEXT_START);
-		*(K_DATA_START);
+		KEEP(*(K_TEXT_START));
+		KEEP(*(K_DATA_START));
 		unmapped_end = .;
 	}
 
-	.mapped (PA2KA(BOOT_OFFSET) + SIZEOF_HEADERS + SIZEOF(.unmapped)): AT (BOOT_OFFSET + SIZEOF_HEADERS + SIZEOF(.unmapped)) {
+	.text (PA2KA(BOOT_OFFSET) + SIZEOF_HEADERS + SIZEOF(.unmapped)): AT (BOOT_OFFSET + SIZEOF_HEADERS + SIZEOF(.unmapped)) {
 		ktext_start = .;
 		*(.text .text.*);
 		ktext_end = .;
+	}
 
+	/* stack unwinding data */
+	.eh_frame_hdr : {
+		eh_frame_hdr_start = .;
+		*(.eh_frame_hdr) *(.eh_frame_entry .eh_frame_entry.*);
+		eh_frame_hdr_end = .;
+	}
+	.eh_frame : {
+		eh_frame_start = .;
+		KEEP(*(.eh_frame .eh_frame.*));
+		eh_frame_end = .;
+	}
+
+	.data : {
 		kdata_start = .;
-		*(.data);               /* initialized data */
-		*(.rodata .rodata.*);   /* string literals */
-		*(COMMON);              /* global variables */
+		*(.rodata .rodata.*);  /* read-only global variables */
+		*(.data .data.*);      /* non-zero initialized global variables */
 
-		/* bss can't be omitted from the ELF image. */
-		*(.bss);                /* uninitialized static variables */
+		/*
+		 * When .bss is not physically present in the ELF file (MemSz > FileSz)
+		 * the kernel crashes during early boot. Not sure which part of the
+		 * boot process is to blame, for now just keep .bss packaged with .data
+		 * so that FileSz == MemSz.
+		 */
 
-		. = ALIGN(8);
-		symbol_table = .;
-		*(symtab.*);            /* Symbol table, must be LAST symbol! */
+		 *(.bss .bss.*);        /* uninitialized global variables */
+		*(COMMON);             /* non-`static` global variables without an extern declaration */
 		kdata_end = .;
 	}
 
-#ifdef CONFIG_LINE_DEBUG
 	.comment 0 : { *(.comment); }
 	.debug_abbrev 0 : { *(.debug_abbrev); }
+	.debug_abbrev.dwo 0 : { *(	.debug_abbrev.dwo); }
+	.debug_addr 0 : { *(.debug_addr); }
 	.debug_aranges 0 : { *(.debug_aranges); }
+	.debug_cu_index 0 : { *(.debug_cu_index); }
+	.debug_frame 0 : { *(.debug_frame); }
+	.debug_frame_hdr 0 : { *(.debug_frame_hdr); }
 	.debug_info 0 : { *(.debug_info); }
+	.debug_info.dwo 0 : { *(.debug_info.dwo); }
 	.debug_line 0 : { *(.debug_line); }
+	.debug_line.dwo 0 : { *(.debug_line.dwo); }
+	.debug_line_str 0 : { *(.debug_line_str); }
 	.debug_loc 0 : { *(.debug_loc); }
+	.debug_loclists 0 : { *(.debug_loclists); }
+	.debug_loclists.dwo 0 : { *(.debug_loclists.dwo); }
+	.debug_macinfo 0 : { *(.debug_macinfo); }
+	.debug_macro 0 : { *(.debug_macro); }
+	.debug_macro.dwo 0 : { *(.debug_macro.dwo); }
+	.debug_names 0 : { *(.debug_names); }
 	.debug_pubnames 0 : { *(.debug_pubnames); }
 	.debug_pubtypes 0 : { *(.debug_pubtypes); }
 	.debug_ranges 0 : { *(.debug_ranges); }
+	.debug_rnglists 0 : { *(.debug_rnglists); }
 	.debug_str 0 : { *(.debug_str); }
-#endif
+	.debug_str.dwo 0 : { *(.debug_str.dwo); }
+	.debug_str_offsets 0 : { *(.debug_str_offsets); }
+	.debug_str_offsets.dwo 0 : { *(.debug_str_offsets.dwo); }
+	.debug_tu_index 0 : { *(.debug_tu_index); }
+	.debug_types 0 : { *(.debug_types); }
 
 	/DISCARD/ : {
Index: kernel/arch/ia32/include/arch/asm.h
===================================================================
--- kernel/arch/ia32/include/arch/asm.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia32/include/arch/asm.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -57,8 +57,21 @@
 }
 
-_NO_TRACE static inline void cpu_sleep(void)
-{
-	asm volatile (
+/** Enables interrupts and blocks until an interrupt arrives,
+ * atomically if possible on target architecture.
+ * Disables interrupts again before returning to caller.
+ */
+_NO_TRACE static inline void cpu_interruptible_sleep(void)
+{
+	asm volatile (
+	    "sti\n"
 	    "hlt\n"
+	    "cli\n"
+	);
+}
+
+_NO_TRACE static inline void cpu_spin_hint(void)
+{
+	asm volatile (
+	    "pause\n"
 	);
 }
Index: kernel/arch/ia32/include/arch/context_struct.h
===================================================================
--- kernel/arch/ia32/include/arch/context_struct.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia32/include/arch/context_struct.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -37,6 +37,5 @@
 #define CONTEXT_OFFSET_EBP  0x14
 #define CONTEXT_OFFSET_TP   0x18
-#define CONTEXT_OFFSET_IPL  0x1c
-#define CONTEXT_SIZE        0x20
+#define CONTEXT_SIZE        0x1c
 
 #ifndef __ASSEMBLER__
@@ -53,5 +52,4 @@
 	uint32_t ebp;
 	uint32_t tp;
-	ipl_t ipl;
 } context_t;
 
Index: kernel/arch/ia32/include/arch/fpu_context.h
===================================================================
--- kernel/arch/ia32/include/arch/fpu_context.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia32/include/arch/fpu_context.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -38,8 +38,6 @@
 #include <stdint.h>
 
-#define FPU_CONTEXT_ALIGN  16
-
 typedef struct {
-	uint8_t fpu[512];  /* FXSAVE & FXRSTOR storage area */
+	_Alignas(16) uint8_t fpu[512];  /* FXSAVE & FXRSTOR storage area */
 } fpu_context_t;
 
Index: kernel/arch/ia32/include/arch/mm/page.h
===================================================================
--- kernel/arch/ia32/include/arch/mm/page.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia32/include/arch/mm/page.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -190,5 +190,6 @@
 	    p->writeable << PAGE_WRITE_SHIFT |
 	    1 << PAGE_EXEC_SHIFT |
-	    p->global << PAGE_GLOBAL_SHIFT);
+	    p->global << PAGE_GLOBAL_SHIFT |
+	    p->page_write_through << PAGE_WRITE_COMBINE_SHIFT);
 }
 
@@ -197,9 +198,18 @@
 	pte_t *p = &pt[i];
 
-	p->page_cache_disable = !(flags & PAGE_CACHEABLE);
 	p->present = !(flags & PAGE_NOT_PRESENT);
 	p->uaccessible = (flags & PAGE_USER) != 0;
 	p->writeable = (flags & PAGE_WRITE) != 0;
 	p->global = (flags & PAGE_GLOBAL) != 0;
+
+	if (flags & PAGE_WRITE_COMBINE) {
+		/* We have mapped PCD+PWT bits to write-combine mode via PAT MSR. */
+		/* (If PAT is unsupported, it will default to uncached.) */
+		p->page_cache_disable = 1;
+		p->page_write_through = 1;
+	} else {
+		p->page_cache_disable = !(flags & PAGE_CACHEABLE);
+		p->page_write_through = 0;
+	}
 
 	/*
Index: kernel/arch/ia32/include/arch/mm/pat.h
===================================================================
--- kernel/arch/ia32/include/arch/mm/pat.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ kernel/arch/ia32/include/arch/mm/pat.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,1 @@
+../../../../amd64/include/arch/mm/pat.h
Index: kernel/arch/ia32/src/boot/vesa_real.inc
===================================================================
--- kernel/arch/ia32/src/boot/vesa_real.inc	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia32/src/boot/vesa_real.inc	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -21,5 +21,5 @@
 #define VESA_END_OF_MODES  0xffff
 
-#define VESA_OK  0x4f
+#define VESA_OK  0x004f
 
 #define VESA_GET_INFO       0x4f00
@@ -180,5 +180,5 @@
 
 	pop %di
-	cmp $VESA_OK, %al
+	cmp $VESA_OK, %ax
 	jnz no_mode
 
@@ -207,5 +207,5 @@
 		pop %di
 		pop %cx
-		cmp $VESA_OK, %al
+		cmp $VESA_OK, %ax
 		jne no_mode
 
@@ -254,5 +254,5 @@
 
 		pop %di
-		cmp $VESA_OK, %al
+		cmp $VESA_OK, %ax
 		jnz no_mode
 
@@ -364,5 +364,28 @@
 
 		/* No prefered mode found */
-
+		push %di
+		mov $e_vesa_init - vesa_init, %di
+		mov 2 + VESA_MODE_LIST_PTR_OFFSET(%di), %si
+		mov %si, %gs
+		mov VESA_MODE_LIST_PTR_OFFSET(%di), %si
+		pop %di
+
+		/* Check if list of supported modes contains fallback mode */
+	find_fallback_mode:
+
+		mov %gs:(%si), %cx
+
+		cmp $0x111, %cx
+		je fallback_mode_listed
+
+		cmp $VESA_END_OF_MODES, %cx
+		je text_mode
+
+		inc %si
+		inc %si
+		jmp find_fallback_mode /* 16-bit relative jump */
+
+	fallback_mode_listed:
+		/* Make sure fallback mode is really supported */
 		mov $0x111, %cx
 		push %di
@@ -373,7 +396,13 @@
 		pop %cx
 		pop %di
-		cmp $VESA_OK, %al
+		cmp $VESA_OK, %ax
 		jnz text_mode
-		jz set_mode  /* force relative jump */
+
+		/* Verify mode attributes */
+		and $0x99, %ax
+		cmp $0x99, %ax
+		jne text_mode
+
+		jmp set_mode  /* 16-bit relative jump */
 
 	text_mode:
Index: kernel/arch/ia32/src/cpu/cpu.c
===================================================================
--- kernel/arch/ia32/src/cpu/cpu.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia32/src/cpu/cpu.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -71,10 +71,10 @@
 void fpu_disable(void)
 {
-	write_cr0(read_cr0() & ~CR0_TS);
+	write_cr0(read_cr0() | CR0_TS);
 }
 
 void fpu_enable(void)
 {
-	write_cr0(read_cr0() | CR0_TS);
+	write_cr0(read_cr0() & ~CR0_TS);
 }
 
@@ -86,6 +86,4 @@
 	CPU->arch.tss = tss_p;
 	CPU->arch.tss->iomap_base = &CPU->arch.tss->iomap[0] - ((uint8_t *) CPU->arch.tss);
-
-	CPU->fpu_owner = NULL;
 
 	cpuid(INTEL_CPUID_STANDARD, &info);
Index: kernel/arch/ia32/src/ia32.c
===================================================================
--- kernel/arch/ia32/src/ia32.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia32/src/ia32.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,5 +1,5 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2001-2004 Jakub Jermar
- * Copyright (c) 2009 Jiri Svoboda
  * Copyright (c) 2009 Martin Decky
  * All rights reserved.
@@ -39,5 +39,5 @@
 #include <stdint.h>
 #include <errno.h>
-#include <mem.h>
+#include <memw.h>
 #include <interrupt.h>
 #include <console/console.h>
@@ -61,4 +61,5 @@
 #include <arch/pm.h>
 #include <arch/vreg.h>
+#include <arch/mm/pat.h>
 
 #ifdef CONFIG_SMP
@@ -104,4 +105,10 @@
 {
 	pm_init();
+
+#ifndef PROCESSOR_i486
+	/* Use PCD+PWT bit combination in PTE to mean write-combining mode. */
+	if (pat_supported())
+		pat_set_mapping(false, true, true, PAT_TYPE_WRITE_COMBINING);
+#endif
 
 	if (config.cpu_active == 1) {
